#include <iostream>
#include <vector>
#include <memory>

class person{
public:
     std::string name;
     int id;
     std::string hobby;
     person()
           : name("NA"), id(-1), hobby("NA"){}
     person(std::string _name, int _age, std::string _hobby)
            : name(_name), id(_age), hobby(_hobby){}
     ~person(){}

};

// // Wrong
// person* register_person(){
//      person a("alicia", 1, "chess");
//      return &a;
// }

// // fix 0, but not suggested
// person* register_people(){
//      person* a = new person("alicia", 1, "chess");
//      return a;
// }

// fix 1. Return by value
// person register_people(){
//      person a("alicia", 1, "chess");
//      return a;
// }


// fix 2. Use smart pointers
std::unique_ptr<person> register_people(){
     std::unique_ptr<person> a = std::make_unique<person>("alicia", 1, "chess"));
     return std::move(a);
}

int main(){
     std::unique_ptr<person> b = register_people();
     std::cout << b[0]->hobby << std::endl;      
     return 0;
}